/*
    Copyright (C) 2008  Colin Caprani - www.colincaprani.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include<iostream>
#include<vector>
#include "Matrix.h"

using namespace std;

void init();

CMatrix<int> m(3, 3, 3);

void main()
{
	init();

	cout << "Matrix Created" << endl;

	for (int i = 1; i <= m.dim(1); i++) 
	{
		for (int j = 1; j <= m.dim(2); j++)
		{
			for (int k = 1; k <= m.dim(3); k++)
				cout << m(i,j,k) << '\t';
			cout << '\n';
		}
		cout << '\n';
		cout << '\n';
	}

	m.add(3,3,4);

	for (i = 1; i <= m.dim(1); i++)
	{
		for (int j = 1; j <= m.dim(2); j++)
			for (int k = 1; k <= m.dim(3); k++)
				m(i,j,k) = 100 * i + 10*j + k;
	}

	for (i = 1; i <= m.dim(1); i++) 
	{
		for (int j = 1; j <= m.dim(2); j++)
		{
			for (int k = 1; k <= m.dim(3); k++)
				cout << m(i,j,k) << '\t';
			cout << '\n';
		}
		cout << '\n';
		cout << '\n';
	}

	std::vector<double> temp[4][4];

	for (i = 1; i <= 3; i++)
	{
		for (int j = 1; j <= 3; j++)
			for (int k = 1; k <= 5; k++)
				temp[i][j].push_back(100 * i + 10*j + k);
	}

	for (i = 1; i <= 3; i++) 
	{
		for (int j = 1; j <= 3; j++)
		{
			for (int k = 1; k <= 5; k++)
				cout << temp[i][j].at(k-1) << '\t';
			cout << '\n';
		}
		cout << '\n';
		cout << '\n';
	}


}

void init()
{
	for (int i = 1; i <= m.dim(1); i++)
	{
		for (int j = 1; j <= m.dim(2); j++)
			for (int k = 1; k <= m.dim(3); k++)
				m(i,j,k) = 100 * i + 10*j + k;
	}
	
}